
cleanup_junctors(Constr, OutConstr) :-
	write('to clean: '),
	writeln(Constr),
	Constr =.. [Junctor|Arguments],
	% Junctor != '.'
	cleanup_junctors_list(Arguments, CleanedArguments),
	length(CleanedArguments, L),
	write('cleaned arguments: '),
	writeln(CleanedArguments),
	((L \== 1; constraint_with_arity_one(CleanedArguments)) -> 
	    OutConstr   =.. [Junctor|CleanedArguments];
	    [OutConstr] =   CleanedArguments),
	write('cleaned to '),
	writeln(OutConstr),

d( [] , [] ).

cleanup_junctors_list([],[]).
cleanup_junctors_list([F1|R1], [F2|R2]) :-
	cleanup_junctors_sub(F1, F2),
	cleanup_junctors_list(R1, R2).

cleanup_junctors_sub(Constr, OutConstr) :-
	write('cleanup_junctors_sub: '),
	writeln(Constr),
	Constr =.. [Junctor|Arguments],
	(Junctor == '.' -> OutConstr = Constr;
	    writeln('--------------->'),
	    cleanup_junctors_list(Arguments, CleanedArguments),
	    writeln('<---------------'),
	    writeln('prefix: '),
	    write(CleanedArguments),
	    prefix_junctor(CleanedArguments, Junctor, OutConstr)),
            write(' -> '),
	    writeln(OutConstr).

prefix_junctor([[LS, RS]], _, [LS, RS]) :-
	length(LS, 1), !.
prefix_junctor([[LS, RS]], Junctor, Out) :- !,
	Out =.. [Junctor|[LS, RS]].
prefix_junctor(Args, _, Out) :-
	length(Args, 1), !,
	[Out] = Args.
prefix_junctor(Args, Junctor, Out) :-
	Out =.. [Junctor|Args].

constraint_with_arity_one([[LS, _]]) :-
	length(LS, 1).
